package it.uniroma1.dis.mfis.redia.verifint.control;

import it.uniroma1.dis.mfis.redia.verifint.control._exceptions.ApplicationException;

public class Application
{
	private static Application instance;
	private boolean running;

	protected Application() {
		this.running = false;
	}

	public static Application getInstance() {
		if(instance==null) {
			instance = new Application();
			return instance;
		}
		return instance;
	}

	public boolean start()
	{
		if (this.isRunning())
			return false;
		this.running = true;

		try {
		    Archive archivio = Archive.getInstance();
		    archivio.load();
		}
		catch (Exception e) {
			this.manageException(e);
		}
		return true;
	}

	public boolean isRunning() {
		return this.running;
	}

	protected void term() {
		this.running = false;
	}

	public void manageException(Exception err) {
		if (err instanceof ApplicationException) {
			// TODO mostra in qualche modo gli errori!!!
			this.term();
		}
		else {
			this.term();
		}
	}
}