package it.uniroma1.dis.mfis.redia.verifint.control;

import java.util.HashMap;
import java.util.SortedSet;
import java.util.TreeSet;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams.CCDDiagram;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types.CTBaseType;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._interfaces.CTType;

public class ConceptualClassDiagramManager {
	private CCDDiagram diagram;
	private SortedSet<CTType> types;

	public ConceptualClassDiagramManager(Archive archive) {
		super();
		this.diagram = archive.getConceptualClassDiagram();
		this.types = new TreeSet<CTType>(archive.getConceptuaDataTypes());
	}

	public ConceptualClassDiagramManager() {
		super();
	}

	public CCDDiagram getDiagram() {
		return diagram;
	}

	void setDiagram(CCDDiagram diagram) {
		this.diagram = diagram;
	}

	public HashMap<String,CTBaseType> getBaseTypes() {
		return CTBaseType.getBaseTypes();
	}

	public SortedSet<CTType> getTypes() {
		return types;
	}

	protected void setTypes(SortedSet<CTType> types) {
		this.types = types;
	}
}