package it.uniroma1.dis.mfis.redia.verifint.control.io;

import java.io.StringWriter;

import javax.xml.bind.*;

import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.XmlSerializable;

public class XmlMarshaller {
	public String marshal(XmlSerializable xmlSerializableElement) {
		// XmlSerializable is an interface, and JAXB can't handle interfaces
		Object xmlSerializableObject = (Object)xmlSerializableElement;
		StringWriter marshalledInstanceWriter = new StringWriter();
		try {
			JAXBContext jaxbContext =
				JAXBContext.newInstance(xmlSerializableObject.getClass());
			Marshaller marshaller = jaxbContext.createMarshaller();
			marshaller.setProperty(
					Marshaller.JAXB_FORMATTED_OUTPUT, new Boolean(true));
			marshaller.marshal(
					xmlSerializableElement, marshalledInstanceWriter);
		}
		catch (Exception e) {
			e.printStackTrace(System.out);
		}
		return marshalledInstanceWriter.toString();
	}
}