package it.uniroma1.dis.mfis.redia.verifint.model._dataTypes;

import java.io.Serializable;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlValue;

import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.Identifiable;

@XmlAccessorType(XmlAccessType.FIELD)
public class ElementId
implements Serializable, Identifiable
{
	private static final long serialVersionUID = -1807424251073658641L;
	@XmlValue
	@XmlID
	private final String id;
	
	protected ElementId() {
		super();
		this.id = null;
	}

	public ElementId(String id) {
		super();
		this.id = id;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object o) {
		return this.id.equals(((ElementId)o).id);
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return this.id.toString();
	}

	public int compareTo(Identifiable o) {
		return this.id.compareTo(o.toString());
	}

	public ElementId getId() {
		return this;
	}
}