package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.NameIdentifiable;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types.CTDataType;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._interfaces.CTDataTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._links.CTDataType_isTypeOf_CTDataTypeDefined;

public class CCDAttribute extends CCDProperty implements CTDataTypeDefined {
	private static final long serialVersionUID = 2210353279817460325L;
	
	protected CCDAttribute() {
		super();
	}

	CCDAttribute(String name, Multiplicity multiplicity) {
		super(name, multiplicity);
	}

	CCDAttribute(String name) {
		this(name,
				new Multiplicity(
						DEFAULT_MINIMUM_MULTIPLICITY,
						DEFAULT_MAXIMUM_MULTIPLICITY
					)
				);
	}

	public CTDataType getType() {
		return (CTDataType)super.getType();
	}

	protected void setType(CTDataType type) {
		super.setType(type);
	}

	public void setType(CTDataType_isTypeOf_CTDataTypeDefined link)
	throws AssociationTargetException {
		if (!link.getDataTypeDefined().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		super.setType(link.getDataType());
	}

	public void unsetType(CTDataType_isTypeOf_CTDataTypeDefined link)
	throws AssociationTargetException {
		if (!link.getDataTypeDefined().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		super.unsetType();
	}

	@Override
	public String getIdentifierName() {
		return
			super.getOwnerRelation().getIdentifierName() +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			this.getName();
	}
}