package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDDiagram_isComposedBy_CCDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_hasProperty_CCDProperty;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types.CTDataType;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._links.CTDataType_isTypeOf_CTDataTypeDefined;

public class CCDAttribute_Factory {
	private CCDAttribute attribute;

	public CCDAttribute createInstance(CCDDiagram diagram,
			CCDRelation ownerRelation, CTDataType type,
			String name, Multiplicity multiplicity) {
		this.attribute = new CCDAttribute(name, multiplicity);
		this.resolveLinkConstraints(diagram, ownerRelation, type);
		return this.attribute;
	}

	public CCDAttribute createInstance(CCDDiagram diagram,
			CCDRelation ownerRelation, CTDataType type,
			String name) {
		this.attribute = new CCDAttribute(name);
		this.resolveLinkConstraints(diagram, ownerRelation, type);
		return this.attribute;
	}

	private void resolveLinkConstraints(CCDDiagram diagram,
			CCDRelation ownerRelation, CTDataType type) {
		CCDDiagram_isComposedBy_CCDElement.addLink(
				diagram, this.attribute);
		CCDRelation_hasProperty_CCDProperty.addLink(
				ownerRelation, this.attribute);
		CTDataType_isTypeOf_CTDataTypeDefined.addLink(
				type, this.attribute);
	}
}
