package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import java.util.SortedSet;
import java.util.TreeSet;

import javax.xml.bind.annotation.*;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDClass_isBaseClassOf_CCDGeneralization;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDClass_isSubClassOf_CCDGeneralization;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDClass_participates_CCDRole;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._interfaces.CTType;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._interfaces.CTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._links.CTType_isTypeOf_CTTypeDefined;

public class CCDClass extends CCDRelation implements CTType {
	private static final long serialVersionUID = 1515500843449679294L;
	@XmlTransient
	private SortedSet<CCDRole> roles;
	@XmlTransient
	private SortedSet<CCDGeneralization> generalizationsWhoseSubClass;
	@XmlTransient
	private SortedSet<CCDGeneralization> generalizationsWhoseBaseClass;
	@XmlTransient
	private SortedSet<CTTypeDefined> definedElements;
	
	protected CCDClass() {
		super();
	}
	
	CCDClass(String name) {
		super(name);
		this.roles = new TreeSet<CCDRole>();
		this.generalizationsWhoseBaseClass = new TreeSet<CCDGeneralization>();
		this.generalizationsWhoseSubClass = new TreeSet<CCDGeneralization>();
		this.definedElements = new TreeSet<CTTypeDefined>();
	}

	public SortedSet<CCDRole> getRoles() {
		return new TreeSet<CCDRole>(this.roles);
	}

	protected void setRoles(SortedSet<CCDRole> ruoli) {
		this.roles = new TreeSet<CCDRole>(ruoli);
	}

	public SortedSet<CCDGeneralization> getGeneralizationsWhoseSubClass() {
		return new TreeSet<CCDGeneralization>(this.generalizationsWhoseSubClass);
	}

	protected void setGeneralizationsWhoseSubClass(
			SortedSet<CCDGeneralization> generalizationsWhoseSubClass) {
		this.generalizationsWhoseSubClass = generalizationsWhoseSubClass;
	}

	public SortedSet<CCDGeneralization> getGeneralizationsWhoseBaseClass() {
		return this.generalizationsWhoseBaseClass;
	}

	protected void setGeneralizationsWhoseBaseClass(
			SortedSet<CCDGeneralization> generalizationsWhoseBaseClass) {
		this.generalizationsWhoseBaseClass = generalizationsWhoseBaseClass;
	}

	public SortedSet<CTTypeDefined> getDefinedElements() {
		return new TreeSet<CTTypeDefined>(definedElements);
	}

	protected void setDefinedElements(SortedSet<CTTypeDefined> definedElements) {
		this.definedElements = definedElements;
	}

	public void addRole(CCDClass_participates_CCDRole link)
	throws AssociationTargetException {
		if (!link.getParticipantClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.roles.add(link.getRole());
	}

	public void removeRole(CCDClass_participates_CCDRole link)
	throws AssociationTargetException {
		if (!link.getParticipantClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.roles.remove(link.getRole());
	}

	public void addGeneralizationWhoseSubClass(
			CCDClass_isSubClassOf_CCDGeneralization link)
	throws AssociationTargetException {
		if (!link.getSubClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.generalizationsWhoseSubClass.add(link.getGeneralization());
	}

	public void removeGeneralizationWhoseSubClass(
			CCDClass_isSubClassOf_CCDGeneralization link)
	throws AssociationTargetException {
		if (!link.getSubClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.generalizationsWhoseSubClass.remove(link.getGeneralization());
	}

	public void addGeneralizationWhoseBaseClass(
			CCDClass_isBaseClassOf_CCDGeneralization link)
	throws AssociationTargetException {
		if (!link.getBaseClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.generalizationsWhoseBaseClass.add(link.getGeneralization());
	}

	public void removeGeneralizationWhoseBaseClass(
			CCDClass_isBaseClassOf_CCDGeneralization link)
	throws AssociationTargetException {
		if (!link.getBaseClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.generalizationsWhoseBaseClass.remove(link.getGeneralization());
	}

	public void addTypeDefinedElement(CTType_isTypeOf_CTTypeDefined link)
	throws AssociationTargetException {
		if (!link.getType().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.definedElements.add(link.getTypeDefined());
	}

	public void removeTypeDefinedElement(CTType_isTypeOf_CTTypeDefined link)
	throws AssociationTargetException {
		if (!link.getType().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.definedElements.remove(link.getTypeDefined());
	}
}