package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import java.io.Serializable;
import javax.xml.bind.annotation.*;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.NameIdentifiable;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_isDestinationOf_CCDDependency;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_isSourceOf_CCDDependency;

public class CCDDependency extends CCDComponent
implements Serializable {
	private static final long serialVersionUID = 122690567336519559L;
	public static final String DEFAULT_IDENTIFIER_NAME_INFIX = "_dependsFrom_";

	@XmlElement(required=true)
	@XmlIDREF
	protected CCDRelation destination;
	@XmlElement(required=true)
	@XmlIDREF
	protected CCDRelation source;

	CCDDependency() {
		super();
	}

	CCDDependency(String name) {
		super(name);
	}

	public CCDRelation getDestination() {
		return this.destination;
	}

	protected void setDestination(CCDRelation destination) {
		this.destination = destination;
	}

	public void setDestination(CCDRelation_isDestinationOf_CCDDependency link)
	throws AssociationTargetException {
		if (!link.getDependency().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setDestination(link.getRelation());
	}

	public void unsetDestination(CCDRelation_isDestinationOf_CCDDependency link)
	throws AssociationTargetException {
		if (!link.getDependency().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.destination = null;
	}

	public CCDRelation getSource() {
		return this.source;
	}

	protected void setSource(CCDRelation source) {
		this.source = source;
	}

	public void setSource(CCDRelation_isSourceOf_CCDDependency link)
	throws AssociationTargetException {
		if (!link.getDependency().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setSource(link.getRelation());
	}

	public void unsetSource(CCDRelation_isSourceOf_CCDDependency link)
	throws AssociationTargetException {
		if (!link.getDependency().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.source = null;
	}

	protected void unsetSource() {
		this.source = null;
	}

	protected void unsetDestination() {
		this.destination = null;
	}

	@Override
	public String getIdentifierName() {
		return this.getIdentifierName(DEFAULT_IDENTIFIER_NAME_INFIX);
	}
	
	protected String getIdentifierName(String infix) {
		return
			super.getIdentifierName() +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			this.getSource().getName() +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			infix +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			this.getDestination().getName();
	}
}