package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDDiagram_isComposedBy_CCDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_isDestinationOf_CCDDependency;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_isSourceOf_CCDDependency;

public class CCDDependency_Factory {
	public CCDDependency dependency;

	public CCDDependency createInstance(CCDDiagram diagram,
			CCDRelation source, CCDRelation destination) {
		this.dependency = new CCDDependency();
		this.resolveLinkConstraints(diagram,
				source, destination);
		return this.dependency;
	}

	public CCDDependency createInstance(CCDDiagram diagram,
			String name,
			CCDRelation source, CCDRelation destination) {
		this.dependency = new CCDDependency(name);
		this.resolveLinkConstraints(diagram,
				source, destination);
		return this.dependency;
	}
	
	private void resolveLinkConstraints(CCDDiagram diagram,
			CCDRelation source, CCDRelation destination) {
		CCDDiagram_isComposedBy_CCDElement.addLink(
				diagram, this.dependency);
		CCDRelation_isSourceOf_CCDDependency.addLink(
				source, this.dependency);
		CCDRelation_isDestinationOf_CCDDependency.addLink(
				destination, this.dependency);
	}
}
