package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;
import javax.xml.bind.annotation.*;

import it.uniroma1.dis.mfis.redia.verifint.model.Diagram;
import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.Identifiable;
import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.XmlSerializable;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDDiagram_isComposedBy_CCDElement;

@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class CCDDiagram
implements
	Diagram,
	Comparable<CCDDiagram>,
	Serializable,
	XmlSerializable
{
	private static final long serialVersionUID = 5073021861739689312L;

	@XmlElement
	private String name;
	@XmlTransient
	private SortedSet<CCDElement> elements;

	protected CCDDiagram() {}
	
	public CCDDiagram(String name) {
		this.name = name;
		this.elements = new TreeSet<CCDElement>(); 
	}

	public void addElement(
			CCDDiagram_isComposedBy_CCDElement
				cCDDiagram_isComposedBy_CCDElement) {
		this.elements.add(cCDDiagram_isComposedBy_CCDElement.getElement());
	}

	public void removeElement(
			CCDDiagram_isComposedBy_CCDElement
				cCDDiagram_isComposedBy_CCDElement) {
		this.elements.remove(
				cCDDiagram_isComposedBy_CCDElement.getElement());
	}

	protected void setElements(SortedSet<CCDElement> elements) {
		this.elements = elements;
	}

	public int compareTo(CCDDiagram o) {
		return this.name.compareTo(o.getName());
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof CCDDiagram) {
			CCDDiagram o = (CCDDiagram) obj;
			return this.name.equals(o.getName());			
		}
		return false;
	}
	
	public SortedSet<Identifiable> getElements() {
		return new TreeSet<Identifiable>(this.elements);
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	@XmlElementWrapper(name="components")
	@XmlElements(value={
			@XmlElement(name="class", type=CCDClass.class),
			@XmlElement(name="association", type=CCDAssociation.class),
			@XmlElement(name="dependency", type=CCDDependency.class),
			@XmlElement(name="generalization", type=CCDGeneralization.class),
			@XmlElement(name="specialization", type=CCDSpecialization.class)
	})
	public List<CCDComponent> getComponents() {
		List<CCDComponent> components = new ArrayList<CCDComponent>();
		for (CCDElement element : this.elements) {
			if (element instanceof CCDComponent) {
				components.add((CCDComponent)element);
			}
		}
		return components;
	}
}