package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import java.util.Set;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDClass_isBaseClassOf_CCDGeneralization;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDClass_isSubClassOf_CCDGeneralization;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDDiagram_isComposedBy_CCDElement;

public class CCDGeneralization_Factory {
	public CCDGeneralization generalization;

	public CCDGeneralization createInstance(
			CCDDiagram diagram,
			CCDClass baseClass, CCDClass subClass) {
		this.generalization = new CCDGeneralization();
		this.resolveLinkConstraints(
				diagram, baseClass, subClass);
		return this.generalization;
	}	

	public CCDGeneralization createInstance(
			CCDDiagram diagram,
			Boolean disjoint, Boolean complete,
			CCDClass baseClass, Set<CCDClass> subClasses) {
		this.generalization = new CCDGeneralization(disjoint, complete);
		for (CCDClass subClass : subClasses)
			this.resolveLinkConstraints(
					diagram, baseClass, subClass);
		return this.generalization;
	}

	public CCDGeneralization createInstance(
			CCDDiagram diagram,
			String name,
			CCDClass baseClass, CCDClass subClass) {
		this.generalization = new CCDGeneralization(name);
		this.resolveLinkConstraints(
				diagram, baseClass, subClass);
		return this.generalization;
	}

	public CCDGeneralization createInstance(
			CCDDiagram diagram,
			String name, Boolean disjoint, Boolean complete,
			CCDClass baseClass, Set<CCDClass> subClasses) {
		this.generalization = new CCDGeneralization(name, disjoint, complete);
		for (CCDClass subClass : subClasses)
			this.resolveLinkConstraints(
					diagram, baseClass, subClass);
		return this.generalization;
	}
	
	private void resolveLinkConstraints(
			CCDDiagram diagram,
			CCDClass baseClass, CCDClass subClass) {
		CCDDiagram_isComposedBy_CCDElement.addLink(
				diagram, this.generalization);
		CCDClass_isBaseClassOf_CCDGeneralization.addLink(
				baseClass, this.generalization);
		CCDClass_isSubClassOf_CCDGeneralization.addLink(
				subClass, this.generalization);
	}
}