package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDDiagram_isComposedBy_CCDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_hasProperty_CCDProperty;

public class CCDOperation_Factory {
	public CCDOperation operation;
	
	public CCDOperation createInstance(CCDDiagram diagram,
			String name,
			CCDRelation ownerRelation) {
		this.operation = new CCDOperation(name);
		this.resolveLinkConstraints(diagram, ownerRelation);
		return this.operation;
	}
	
	public CCDOperation createInstance(CCDDiagram diagram,
			String name, Multiplicity multiplicity,
			CCDRelation ownerRelation) {
		this.operation = new CCDOperation(name, multiplicity);
		this.resolveLinkConstraints(diagram, ownerRelation);
		return this.operation;
	}

	private void resolveLinkConstraints(CCDDiagram diagram,
			CCDRelation ownerRelation) {
		CCDDiagram_isComposedBy_CCDElement.addLink(
				diagram, this.operation);
		CCDRelation_hasProperty_CCDProperty.addLink(
				ownerRelation, this.operation);
	}
}