package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import javax.xml.bind.annotation.*;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.NameIdentifiable;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDOperation_hasParameter_CCDParameter;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.operations._interfaces.COpOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.operations._interfaces.COpParameter;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._interfaces.CTType;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._links.CTType_isTypeOf_CTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._xml.CTTypeXmlImplementation;

@XmlAccessorType(XmlAccessType.FIELD)
public class CCDParameter extends CCDInnerComponent
implements COpParameter {
	private static final long serialVersionUID = -5902307283895148766L;

	public static final Short DEFAULT_MINIMUM_MULTIPLICITY = 0;
	public static final Short DEFAULT_MAXIMUM_MULTIPLICITY = 1;

	public static final String DEFAULT_IDENTIFIER_NAME_INFIX = "_parameter_";

	@XmlJavaTypeAdapter(type=CTType.class, value=CTTypeXmlImplementation.Adapter.class)
	@XmlAttribute(required=true)
	private CTType type;
	@XmlElement(required=true)
	private Multiplicity multiplicity;
	@XmlTransient
	private CCDOperation ownerOperation;

	CCDParameter(String name, CTType type, Multiplicity multiplicity) {
		super(name, multiplicity);
		this.type = type;
	}

	CCDParameter(String name, CTType type) {
		this(name, type,
			new Multiplicity(
						DEFAULT_MINIMUM_MULTIPLICITY,
						DEFAULT_MAXIMUM_MULTIPLICITY
					)
		);
	}
	
	protected CCDParameter() {
		super();
	}

	public CTType getType() {
		return this.type;
	}

	protected void setType(CTType type) {
		this.type = type;
	}

	public void setType(CTType_isTypeOf_CTTypeDefined link)
	throws AssociationTargetException {
		if (!link.getTypeDefined().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setType(link.getType());
	}

	public Multiplicity getMultiplicity() {
		return multiplicity;
	}

	public void setMultiplicity(Multiplicity multiplicity) {
		this.multiplicity = multiplicity;
	}

	public COpOperation getOwnerOperation() {
		return ownerOperation;
	}

	protected void setOwnerOperation(CCDOperation ownerOperation) {
		this.ownerOperation = ownerOperation;
	}

	public void setOwnerOperation(CCDOperation_hasParameter_CCDParameter link)
	throws AssociationTargetException {
		if (!link.getParameter().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setOwnerOperation(link.getOperation());
	}

	public void unsetOwnerOperation(CCDOperation_hasParameter_CCDParameter link)
	throws AssociationTargetException {
		if (!link.getParameter().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.ownerOperation = null;
	}
	
	@Override
	public String getIdentifierName() {
		return
			this.ownerOperation.getIdentifierName() +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			DEFAULT_IDENTIFIER_NAME_INFIX +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			this.getName();
	}
}