package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDDiagram_isComposedBy_CCDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDOperation_hasParameter_CCDParameter;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._interfaces.CTType;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._links.CTType_isTypeOf_CTTypeDefined;

public class CCDParameter_Factory {
	public CCDParameter parameter;
	
	public CCDParameter createInstance(CCDDiagram diagram,
			CCDOperation ownerOperation, CTType type,
			String name
			) {
		this.parameter = new CCDParameter(name, type);
		this.resolveLinkConstraints(diagram, ownerOperation, type);
		return this.parameter;
	}
	
	public CCDParameter createInstance(CCDDiagram diagram,
			CCDOperation ownerOperation, CTType type,
			String name,
			Multiplicity multiplicity
			) {
		this.parameter = new CCDParameter(name, type, multiplicity);
		this.resolveLinkConstraints(diagram, ownerOperation, type);
		return this.parameter;
	}
	
	private void resolveLinkConstraints(CCDDiagram diagram,
			CCDOperation ownerOperation, CTType type) {
		CCDDiagram_isComposedBy_CCDElement.addLink(
				diagram, this.parameter);
		CCDOperation_hasParameter_CCDParameter.addLink(
				ownerOperation, this.parameter);
		CTType_isTypeOf_CTTypeDefined.addLink(
				type, this.parameter);
	}
}