package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import javax.xml.bind.annotation.*;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_hasProperty_CCDProperty;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._interfaces.CTType;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.types._xml.CTTypeXmlImplementation;

public abstract class CCDProperty extends CCDInnerComponent {
	public static final Short DEFAULT_MINIMUM_MULTIPLICITY = 0;
	public static final Short DEFAULT_MAXIMUM_MULTIPLICITY = 1;

	@XmlJavaTypeAdapter(type=CTType.class, value=CTTypeXmlImplementation.Adapter.class)
	@XmlAttribute(required=true)
	@XmlIDREF
	protected CTType type;

	@XmlTransient
	protected CCDRelation ownerRelation;

	protected CCDProperty(String name, Multiplicity multiplicity) {
		super(name, multiplicity);
	}

	protected CCDProperty(String name) {
		super(name);
	}
	
	protected CCDProperty() {
		super();
	}

	public CCDRelation getOwnerRelation() {
		return ownerRelation;
	}

	protected void setOwnerRelation(CCDRelation ownerRelation) {
		this.ownerRelation = ownerRelation;
	}

	public void setOwnerRelation(CCDRelation_hasProperty_CCDProperty link)
	throws AssociationTargetException {
		if (!link.getProperty().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setOwnerRelation(link.getRelation());
	}

	public void unsetOwnerRelation(CCDRelation_hasProperty_CCDProperty link)
	throws AssociationTargetException {
		if (!link.getProperty().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.ownerRelation = null;
	}

	public CTType getType() {
		return this.type;
	}

	protected void setType(CTType type) {
		this.type = type;
	}

	protected void unsetType() {
		this.type = null;
	}
}