package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import java.util.SortedSet;
import java.util.TreeSet;

import javax.xml.bind.annotation.*;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_hasProperty_CCDProperty;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_isDestinationOf_CCDDependency;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDRelation_isSourceOf_CCDDependency;

public abstract class CCDRelation extends CCDComponent {
	@XmlElementWrapper(name="properties")
	@XmlElements(value={
			@XmlElement(name="attribute", type=CCDAttribute.class, required=false),
			@XmlElement(name="operation", type=CCDOperation.class, required=false)
		}
	)
	private SortedSet<CCDProperty> properties;
	@XmlTransient
	protected SortedSet<CCDDependency> dependenciesWhoseSource;
	@XmlTransient
	protected SortedSet<CCDDependency> dependenciesWhoseDestination;

	protected CCDRelation() {}
	
	CCDRelation(String name) {
		super(name);
		this.properties = new TreeSet<CCDProperty>();
		this.dependenciesWhoseSource = new TreeSet<CCDDependency>();
		this.dependenciesWhoseDestination = new TreeSet<CCDDependency>();
	}

	public SortedSet<CCDProperty> getProperties() {
		return new TreeSet<CCDProperty>(this.properties);
	}

	protected void setProperties(SortedSet<CCDProperty> properties) {
		this.properties = properties;
	}

	public SortedSet<CCDDependency> getDependenciesWhoseSource() {
		return new TreeSet<CCDDependency>(this.dependenciesWhoseSource);
	}

	protected void setDependenciesWhoseSource(
			SortedSet<CCDDependency> sourceDependencies) {
		this.dependenciesWhoseSource = sourceDependencies;
	}

	public SortedSet<CCDDependency> getDependenciesWhoseDestination() {
		return new TreeSet<CCDDependency>(this.dependenciesWhoseDestination);
	}

	protected void setDependenciesWhoseDestination(
			SortedSet<CCDDependency> destinationDependencies) {
		this.dependenciesWhoseDestination = destinationDependencies;
	}

	public void addProperty(CCDRelation_hasProperty_CCDProperty link)
	throws AssociationTargetException {
		if (!link.getRelation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.properties.add(link.getProperty());
	}

	public void removeProperty(CCDRelation_hasProperty_CCDProperty link)
	throws AssociationTargetException {
		if (!link.getRelation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.properties.remove(link.getProperty());
	}

	protected void addDependencyWhoseSource(CCDDependency dependency) {
		this.dependenciesWhoseSource.add(dependency);
	}

	protected void removeDependencyWhoseSource(CCDDependency dependency) {
		this.dependenciesWhoseSource.remove(dependency);
	}

	protected void addDependencyWhoseDestination(CCDDependency dependency) {
		this.dependenciesWhoseDestination.add(dependency);
	}

	protected void removeDependencyWhoseDestination(CCDDependency dependency) {
		this.dependenciesWhoseDestination.remove(dependency);
	}

	public void addDependencyWhoseSource(
			CCDRelation_isSourceOf_CCDDependency link)
	throws AssociationTargetException {
		if (!link.getRelation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.addDependencyWhoseSource(link.getDependency());
	}

	public void removeDependencyWhoseSource(
			CCDRelation_isSourceOf_CCDDependency link)
	throws AssociationTargetException {
		if (!link.getRelation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.removeDependencyWhoseSource(link.getDependency());
	}

	public void addDependencyWhoseDestination(
			CCDRelation_isDestinationOf_CCDDependency link)
	throws AssociationTargetException {
		if (!link.getRelation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.addDependencyWhoseDestination(link.getDependency());
	}

	public void removeDependencyWhoseDestination(
			CCDRelation_isDestinationOf_CCDDependency link)
	throws AssociationTargetException {
		if (!link.getRelation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.removeDependencyWhoseDestination(link.getDependency());
	}
}