package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import javax.xml.bind.annotation.XmlIDREF;
import javax.xml.bind.annotation.XmlTransient;

import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.NameIdentifiable;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDAssociation_hasRoles_CCDRole;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDClass_participates_CCDRole;

public class CCDRole extends CCDInnerComponent {
	private static final long serialVersionUID = -4008841498574965424L;
	public static final String DEFAULT_IDENTIFIER_NAME_1ST_INFIX = "_roleFor_";
	public static final String DEFAULT_IDENTIFIER_NAME_2ND_INFIX = "_inAssociation_";

	public static final Short DEFAULT_MINIMUM_MULTIPLICITY =
		0;
	public static final Short DEFAULT_MAXIMUM_MULTIPLICITY =
		Multiplicity.UNBOUNDED;
	public static final String DEFAULT_ROLE_NAME = "";
	@XmlIDREF
	private CCDClass participantClass;
	@XmlTransient
	private CCDAssociation association;

	CCDRole(String role, Multiplicity multiplicity) {
		super(role, multiplicity);
	}

	CCDRole(String role) {
		this(role,
				new Multiplicity(
						CCDRole.DEFAULT_MINIMUM_MULTIPLICITY,
						CCDRole.DEFAULT_MAXIMUM_MULTIPLICITY
					)
				);
	}

	CCDRole(Multiplicity multiplicity) {
		this(CCDRole.DEFAULT_ROLE_NAME, multiplicity);
	}

	CCDRole() {
		this(CCDRole.DEFAULT_ROLE_NAME,
				new Multiplicity(
						CCDRole.DEFAULT_MINIMUM_MULTIPLICITY,
						CCDRole.DEFAULT_MAXIMUM_MULTIPLICITY
					)
				);
	}

	public CCDAssociation getAssociation() {
		return this.association;
	}

	protected void setAssociation(CCDAssociation association) {
		this.association = association;
	}
	
	public CCDClass getParticipantClass() {
		return this.participantClass;
	}

	protected void setParticipantClass(CCDClass participantClass) {
		this.participantClass = participantClass;
	}
	
	public void setParticipantClass(CCDClass_participates_CCDRole link)
	throws AssociationTargetException {
		if (!link.getRole().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setParticipantClass(link.getParticipantClass());
	}
	
	public void unsetParticipantClass(CCDClass_participates_CCDRole link)
	throws AssociationTargetException {
		if (!link.getRole().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.participantClass = null;
	}

	public void setAssociation(
			CCDAssociation_hasRoles_CCDRole link)
	throws AssociationTargetException {
		if (!link.getRoles().contains(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setAssociation(link.getAssociation());
	}

	public void unsetAssociation(
			CCDAssociation_hasRoles_CCDRole link)
	throws AssociationTargetException {
		if (!link.getRoles().contains(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.association = null;
	}

	@Override
	public String getIdentifierName() {
		return
			super.getIdentifierName() +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			DEFAULT_IDENTIFIER_NAME_1ST_INFIX +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			this.getParticipantClass().getName() +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			DEFAULT_IDENTIFIER_NAME_2ND_INFIX +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			this.getAssociation().getName();
	}
}