package it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDAssociation_isSubSetOf_CCDSpecialization;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams._links.CCDAssociation_isSuperSetOf_CCDSpecialization;

public class CCDSpecialization extends CCDDependency {	
	private static final long serialVersionUID = -5895502768268811436L;
	public static final String DEFAULT_NAME = "{subset}";
	public static final String DEFAULT_IDENTIFIER_NAME_INFIX = "_isSubSetOf_";

	CCDSpecialization() {
		super(DEFAULT_NAME);
	}

	public CCDAssociation getSuperSet() {
		return (CCDAssociation)super.getDestination();
	}

	protected void setSuperSet(CCDAssociation superSet) {
		super.setDestination(superSet);
	}

	public void setSuperSet(CCDAssociation_isSuperSetOf_CCDSpecialization link)
	throws AssociationTargetException {
		if (!link.getSpecialization().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setSuperSet(link.getAssociation());
	}

	public CCDAssociation getSubSet() {
		return (CCDAssociation)super.getSource();
	}

	protected void setSubSet(CCDAssociation subSet) {
		super.setSource(subSet);
	}

	public void setSubSet(CCDAssociation_isSubSetOf_CCDSpecialization link)
	throws AssociationTargetException {
		if (!link.getSpecialization().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setSubSet(link.getAssociation());
	}

	public void unsetSubSet(CCDAssociation_isSubSetOf_CCDSpecialization link)
	throws AssociationTargetException {
		if (!link.getSpecialization().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		super.unsetSource();
	}

	public void unsetSuperSet(CCDAssociation_isSuperSetOf_CCDSpecialization link)
	throws AssociationTargetException {
		if (!link.getSpecialization().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		super.unsetDestination();
	}

	@Override
	public String getIdentifierName() {
		return super.getIdentifierName(DEFAULT_IDENTIFIER_NAME_INFIX);
	}
}