package it.uniroma1.dis.mfis.redia.verifint.model.analysis.types;

import java.util.HashMap;

public class CTBaseType extends CTDataType {
	private static final long serialVersionUID = 1991433237119863618L;
	public static final CTBaseType STRING_TYPE =
		new CTBaseType("String");
	public static final CTBaseType INTEGER_TYPE =
		new CTBaseType("Integer");  
	public static final CTBaseType POSITIVE_INTEGER_TYPE =
		new CTBaseType("Integer > 0");
	public static final CTBaseType NON_NEGATIVE_INTEGER_TYPE =
		new CTBaseType("Intero >= 0");
	public static final CTBaseType BOOLEAN_TYPE =
		new CTBaseType("Boolean");  
	public static final CTBaseType FLOAT_TYPE =
		new CTBaseType("Float");  
	public static final CTBaseType CHARACTER_TYPE =
		new CTBaseType("Character");  
	public static final CTBaseType BYTE_TYPE =
		new CTBaseType("Byte");
	public static final CTBaseType DATE_TYPE =
		new CTBaseType("Date");
	public static final CTBaseType DATE_TIME_TYPE =
		new CTBaseType("DateTime");
	public static final CTBaseType UNDEFINED_TYPE =
		new CTBaseType("?");
	
	protected CTBaseType() {
		super();
	}
	
	public CTBaseType(String name) {
		super(name);
	}
	
	public static final HashMap<String, CTBaseType> getBaseTypes() {
		HashMap<String, CTBaseType> baseTypesMap =
			new HashMap<String, CTBaseType>(11);
		baseTypesMap.put(
				STRING_TYPE.getName(), STRING_TYPE);
		baseTypesMap.put(
				INTEGER_TYPE.getName(), INTEGER_TYPE);
		baseTypesMap.put(
				POSITIVE_INTEGER_TYPE.getName(), POSITIVE_INTEGER_TYPE);
		baseTypesMap.put(
				NON_NEGATIVE_INTEGER_TYPE.getName(), NON_NEGATIVE_INTEGER_TYPE);
		baseTypesMap.put(
				BOOLEAN_TYPE.getName(), BOOLEAN_TYPE);
		baseTypesMap.put(
				FLOAT_TYPE.getName(), FLOAT_TYPE);
		baseTypesMap.put(
				CHARACTER_TYPE.getName(), CHARACTER_TYPE);
		baseTypesMap.put(
				BYTE_TYPE.getName(), BYTE_TYPE);
		baseTypesMap.put(
				DATE_TYPE.getName(), DATE_TYPE);
		baseTypesMap.put(
				DATE_TIME_TYPE.getName(), DATE_TIME_TYPE);
		baseTypesMap.put(
				UNDEFINED_TYPE.getName(), UNDEFINED_TYPE);
		return baseTypesMap;
	}
}