package it.uniroma1.dis.mfis.redia.verifint.model.constraints._links;

import it.uniroma1.dis.mfis.redia.verifint.model.constraints._interfaces.XConstrainable;
import it.uniroma1.dis.mfis.redia.verifint.model.constraints._interfaces.XConstraint;

public class XConstrainable_satisfies_XConstraint {
	private XConstraint constraint;
	private XConstrainable constrainedElement;
	
	/**
	 * Builds <code>XConstrainable_satisfies_XConstraint</code> instances.
	 * @param constrainedElement
	 * @param constraint
	 */
	private XConstrainable_satisfies_XConstraint(
			XConstrainable constrainedElement, XConstraint constraint) {
		super();
		this.constraint = constraint;
		this.constrainedElement = constrainedElement;
	}
	
	public XConstraint getConstraint() {
		return constraint;
	}

	public XConstrainable getConstrainedElement() {
		return constrainedElement;
	}

	public static void addLink(
			XConstraint constraint, XConstrainable constrainedElement) {
		XConstrainable_satisfies_XConstraint self =
			new XConstrainable_satisfies_XConstraint(constrainedElement, constraint);
		constraint.addConstrainedElement(self);
		constrainedElement.addConstraint(self);
	}
	
	public static void removeLink(
			XConstraint constraint, XConstrainable constrainedElement) {
		XConstrainable_satisfies_XConstraint self =
			new XConstrainable_satisfies_XConstraint(constrainedElement, constraint);
		constraint.removeConstrainedElement(self);
		constrainedElement.removeConstraint(self);
	}
}