package it.uniroma1.dis.mfis.redia.verifint.test.testers;

import it.uniroma1.dis.mfis.redia.verifint.control.ExecutionProperties;
import it.uniroma1.dis.mfis.redia.verifint.control.provers._constants.Prover9Constants;
import it.uniroma1.dis.mfis.redia.verifint.test.MainReDiAVeriFIntTest;

import java.io.FileReader;
import java.io.StringReader;
import java.io.StringWriter;

import javax.xml.transform.*;
import javax.xml.transform.stream.*;

public class XslTester {
	public boolean test(String testCode) throws Exception {
		DiagramToXmlTester diaToXmlTest = new DiagramToXmlTester();
		if (!diaToXmlTest.test(testCode))
			return false;
		
		String xml = diaToXmlTest.getXmlDiagram();
		if (xml == null) {
			return false;
		}
		
		Source xmlSource = new StreamSource(new StringReader(xml));
		Source xsltSource = new StreamSource(
				new FileReader(
						System.getProperty("user.dir") + "/" +
						ExecutionProperties.getInstance().getProperty(
								Prover9Constants.PROVER_9_XSLT_PATH_KEY
							)
					)
			);
		TransformerFactory transFactory = TransformerFactory.newInstance();
		Transformer trans = transFactory.newTransformer(xsltSource);
		StringWriter newXmlWriter = new StringWriter();
		trans.transform(xmlSource, new StreamResult(newXmlWriter));
		
		String[] lines = newXmlWriter.toString().split("\\n");
		StringBuffer stringBuffer = new StringBuffer();
		for(String line : lines) {
			line = line.trim();
			if (!line.equals("")) {
				stringBuffer.append(line + "\n");
			}
		}
		
		System.out.println(stringBuffer.toString());

		return true;
	}

	public void test() throws Exception {
		this.test(MainReDiAVeriFIntTest.DEFAULT_TEST_CODE);
	}
}