/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine;

/**
 * Rappresenta un rettangolo delimitato come vecchia convenzione C/C++
 * Esso e' definito da quattro parametri: Left, top, Right, Bottom.
 * L'uso e' destinato ad agevolare la codifica di alcune routine grafiche.
 * @author Fuego
 */
public class SimpleRect {
    private int top, left, right, bottom;
    
    /**
     * Crea un'istanza di Rettangolo semplice a partire dai suoi quattro limiti
     * basilari
     * @param left limite sinistro
     * @param top limite superiore
     * @param right limite destro
     * @param bottom limite inferiore
     */
    public SimpleRect(int left, int top, int right, int bottom) {
        this.left = left;
        this.top = top;        
        this.right = right;
        this.bottom = bottom;        
    }

    
    /**
     * Restituisce il limite superiore del rettangolo
     * @return limite superiore del rettangolo
     */
    public int getTop() {
        return top;
    }

    /**
     * Restituisce il limite sinistro del rettangolo
     * @return limite sinistro del rettangolo
     */
    public int getLeft() {
        return left;
    }

    /**
     * Restituisce il limite destro del rettangolo
     * @return limite destro del rettangolo
     */
    public int getRight() {
        return right;
    }

    /**
     * Restituisce il limite inferiore del rettangolo
     * @return limite inferiore del rettangolo
     */
    public int getBottom() {
        return bottom;
    }
            
}
