package it.uniroma1.dis.mfis.redia.verifint.view.widgets;

import java.awt.Color;
import java.awt.Component;
import java.awt.LayoutManager;
import java.util.HashMap;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class Container extends Widget {
	private Boolean singleLine;
	public String id;
	public Map<String, Widget> widgets = new HashMap<String, Widget>();

	public Container() {
		super();
	}

	public Container(String id) {
		super();
		this.id = id;
	}

	public Container(String id, Boolean singleLine) {
		this(id);
		this.singleLine = singleLine;
	}

	public Container(Boolean singleLine) {
		this();
		this.singleLine = singleLine;
	}

	public Boolean isSingleLine() {
		return singleLine;
	}

	protected void setSingleLine(Boolean singleLine) {
		this.singleLine = singleLine;
	}

	@Override
	public Component generateGraphicComponent() {
		JPanel panel = new JPanel();
		LayoutManager panelLayout =
			((this.singleLine) ?
					new BoxLayout(panel, BoxLayout.X_AXIS) :
					new BoxLayout(panel, BoxLayout.Y_AXIS)
			);
		panel.setLayout(panelLayout);

		if (this.label != null) {
			panel.setBorder(
					BorderFactory.createTitledBorder(
							BorderFactory.createLineBorder(Color.black),
							this.label,
							TitledBorder.LEFT,
							TitledBorder.TOP));
		}
		for (Widget widget : this.widgets.values()) {
			panel.add(widget.generateGraphicComponent());
		}
		return panel;
	}
}
